#!/usr/bin/php4 -q
<?

/*

aEGiS PHP nano web server
=========================

Copyright (C) 2000-2002 Vincent Negrier aka. sIX <six@aegis-corp.org>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

define(VERSION, "1.1.0");

define(DEFAULT_CONFIG_FILE, "nanoweb.conf");
define(DEFAULT_LISTEN_ADDR, "0.0.0.0");
define(DEFAULT_LISTEN_DEFAULT_PORT, 80);
define(DEFAULT_LISTEN_QUEUE, 20);
define(DEFAULT_MIMETYPES, "/etc/mime.types");
define(DEFAULT_SSI_EXT, "shtml");
define(HTTP_VERSION, "HTTP/1.1");

$HTTP_HEADERS=array	(	200 => "200 OK",
						403 => "403 Forbiden",
						404 => "404 Not Found",
						500 => "500 Internal Server Error" );

// Functions

function _parseconfig_close_part(&$conf, $cpart) {

	if ($cpart=="global") {

		if (!$conf[$cpart]["listeninterface"]) $conf[$cpart]["listeninterface"]=DEFAULT_LISTEN_ADDR;
		if (!$conf[$cpart]["listenport"]) $conf[$cpart]["listenport"]=DEFAULT_LISTEN_PORT;
		if (!$conf[$cpart]["listenqueue"]) $conf[$cpart]["listenqueue"]=DEFAULT_LISTEN_QUEUE;
		if (!$conf[$cpart]["mimetypes"]) $conf[$cpart]["mimetypes"]=DEFAULT_MIMETYPES;
		if (!$conf[$cpart]["ssiparseextension"]) $conf[$cpart]["ssiparseextension"]=DEFAULT_SSI_EXT;
		if (!$conf[$cpart]["documentroot"]) $conf[$cpart]["documentroot"]="./";
		if (!$conf[$cpart]["log"]) $conf[$cpart]["log"]="./access.log";

	}

	if (!$conf[$cpart]["documentroot"]) $conf[$cpart]["documentroot"]=$conf["global"]["documentroot"];
	if (!$conf[$cpart]["directoryindex"]) $conf[$cpart]["directoryindex"]=$conf["global"]["directoryindex"];
	if (!$conf[$cpart]["log"]) $conf[$cpart]["log"]=$conf["global"]["log"];

	return(true);

}

function parseconfig($conf_arr) {

	if ($conf_arr) while (list($key, $str)=each($conf_arr)) {

		switch ($str[0]) {

			case "#":
			case ";":
			case "\n":
			break;
			
			case "[":
			if ($cpart) _parseconfig_close_part($conf, $cpart); 
			$cpart=substr(trim($str), 1, -1);
			break;

			default:
			$cnfk=strtolower(substr($str, 0, strpos($str, "=")));
			$cnfv=trim(substr($str, strpos($str,"=")+1, strlen($str)));
			$conf[$cpart][trim($cnfk)]=trim($cnfv);
			break;
		
		}
		
	}

	_parseconfig_close_part($conf, $cpart);
	
	return($conf);

}

function techo($s) {

	echo date("Ymd-His")." - $s\n";
	flush();

}

function errexit($s) {

	techo("FATAL: ".$s);
	exit;

}

function loadfile($filename, $extension) {
	
	global $conf, $docroot;
	
	$f=fopen($filename, "r");
	$content=fread($f, filesize($filename));
	fclose($f);

	if ($extension==$conf["global"]["ssiparseextension"]) {

		while (($p1=strpos($content, "<!--#"))!==false) {

			$s=substr($content, $p1+5);
			if (!$p2=strpos($s, "-->")) techo("WARN: SSI parse error in ".$filename);
			$s=trim(substr($s, 0, $p2));
			$tmp=explode("=", $s);
			if (count($tmp)!=2) techo("WARN: SSI parse error in ".$filename);
			$cmd=strtolower(trim($tmp[0]));
			$arg=trim($tmp[1]," \"");

			switch($cmd) {

				case "include virtual":
				$ext=strstr($arg, ".");
				$repl=loadfile($docroot.$arg, substr($ext, 1));
				break;

				case "include file":
				$ext=strstr($arg, ".");
				$repl=loadfile("./".$arg, substr($ext, 1));
				break;

				case "exec cmd":
				$repl=`$arg`;
				break;
			
			}
			
			$content=substr($content, 0, $p1).$repl.substr($content, $p1+$p2+8);

		}
	
	}
	
	return($content);

}

// Begin

set_time_limit(0);

techo("aEGiS nanoweb/".VERSION." (c)2002 by sIX <six@aegis-corp.org>");

if ($argv[1]) $conffile=$argv[1]; else $conffile=DEFAULT_CONFIG_FILE;
if (!is_readable($conffile)) errexit("unable to read configuration (".$conffile."), aborting");
$conf=parseconfig(file($conffile));

if (!@is_readable($conf["global"]["mimetypes"])) {

	techo("WARN: unable to read mime types file (".$conf["global"]["mimetypes"]."), using internals");

	$mime["default"]="text/plain";
	$mime["html"]="text/html";
	$mime["gif"]="image/gif";
	$mime["jpeg"]="image/jpeg";
	$mime["png"]="image/png";
	$mime["tgz"]="application/gtar";

} else if ($mimetypes=file("/etc/mime.types")) {
	
	// Load mime types from /etc/mime.types
	
	while (list($key, $s)=each($mimetypes)) if (trim($s) && ($s[0]!="#")) if (ereg("([a-zA-Z0-9/.-]+)[ \t]+([a-zA-Z0-9 -]+)", $s, $res)) if ($exts=explode(" ", trim($res[2]))) while (list($key2, $ext)=each($exts)) if (trim($res[1]) && trim($ext)) $mime[$ext]=trim($res[1]);

}

if (($sock = @socket_create(AF_INET, SOCK_STREAM, 0))<0) errexit("socket() failed: ".socket_strerror($sock));
if (($ret = @socket_bind($sock, $conf["global"]["listeninterface"], $conf["global"]["listenport"]))<0) errexit("bind() failed: ".socket_strerror($ret));
if (($ret = @socket_listen($sock, $conf["global"]["listenqueue"]))<0) errexit("listen() failed: ".socket_strerror($ret));

$run=1;

techo("running and accepting connections on port ".$conf["global"]["listenport"]);

while ($run) {

	if (($msgsock = @socket_accept($sock)) < 0) {

		techo("accept_connect() failed: reason: ".socket_strerror($msgsock));
		sleep(10);

	}

	$remote_ip="";
	$remote_port=0;
	@socket_getpeername($msgsock, &$remote_ip, &$remote_port);

	if (!$remote_host=gethostbyaddr($remote_ip)) $remote_host=$remote_ip;

	$cnx=true;
	unset($cmds);

	while ($cnx) {

		$buf=@socket_read($msgsock, 2048);
        $cmds.=$buf;

//		Uncomment when PHP people finally get this working
//		$sst=socket_get_status($msgsock);
//		if ($sst["timed_out"] || $sst["blocked"] || $sst["eof"]) $cnx=false;

		if ($cnx) {

			$tmp_arr=explode("\n",$cmds);

			if (trim($tmp_arr[count($tmp_arr)-1])=="" && trim($tmp_arr[count($tmp_arr)-2])=="") {

				$htreq=explode(" ", trim($tmp_arr[0]));
				$http_action=strtoupper($htreq[0]);

				// Decode HTTP request headers
				
				unset($htreq_headers);
				
				for($a=1;$a<=count($tmp_arr);$a++) if ($s=trim($tmp_arr[$a])) {

					$hd_key=strtoupper(substr($s, 0, strpos($s, ":")));
					$hd_val=trim(substr($s,strpos($s, ":")+1));

					$htreq_headers[$hd_key]=$hd_val;

				}

				$out_headers="";
				$out_content="";
				$out_contenttype="";
				$rq_err=0;

				switch ($http_action) {

					case "GET":
					case "POST":

					$host=trim(strtolower($htreq_headers["HOST"]));
					$host=substr($host, 0, strpos($host, ":"));
					if (is_array($conf[$host])) $vhost=$host; else $vhost="global";

					$docroot=$conf[$vhost]["documentroot"];
					
					$complete_path=$http_uri=urldecode($htreq[1]);
					while ($http_uri[0]=="/") $http_uri=substr($http_uri, 1);
					while (strpos("../", $http_uri)!==false) $http_uri=str_replace("../", "", $http_uri);
					$http_protocol=$htreq[2];

					$rq_file=pathinfo($http_uri);

					if (!$rq_file["basename"]) {
						
						$http_uri=$rq_file["dirname"]."/".$conf[$vhost]["directoryindex"];
						$rq_file=pathinfo($http_uri);
						while ($http_uri[0]=="/") $http_uri=substr($http_uri, 1);
						while (strpos("../", $http_uri)!==false) $http_uri=str_replace("../", "", $http_uri);

					}

					if (!is_dir($docroot.$rq_file["dirname"])) $rq_err=404;
					else if (!@is_file($docroot.$http_uri) && !@is_link($docroot.$http_uri)) $rq_err=404;
					else if (!is_readable($docroot.$http_uri)) $rq_err=403;
					else {

						$rq_err=200;
						
						$file_content=loadfile($docroot.$http_uri, $rq_file["extension"]);

						if ($mimetype=$mime[strtolower($rq_file["extension"])]) $out_contenttype=$mimetype; else $out_contenttype="text/plain";
						if (!$out_content) $out_content=$file_content;

					}

					break;

					case "HEAD":

					$host="";
					$complete_path="";
					$rq_err=200;
					$out_contenttype="text/html";
					$out_content="";
					
					break;

				}

				if ($rq_err!=200) {
					
					$out_contenttype="text/html";
					$out_content="<html><head><title>".$HTTP_HEADERS[$rq_err]."</title></head><body><h1>".$HTTP_HEADERS[$rq_err]."</h1></body></html>";
				
				}
				
				$out_headers=HTTP_VERSION." ".$HTTP_HEADERS[$rq_err]."\r\n";
				$out_headers.="Date: ".date("D, d M Y H:i:s T")."\r\n";
				$out_headers.="Server: aEGiS_nanoweb/".VERSION." (PHP/".phpversion().")\r\n";
				$out_headers.="Connection: close\r\n";
				$out_headers.="Content-Type: ".$out_contenttype."\r\n";

				if ($out_content && strpos($htreq_headers["ACCEPT-ENCODING"], "gzip")!==false) {
					
					$out_headers.="Content-Encoding: gzip\r\n";
					$out_content=gzencode($out_content);
				
				}

				$response=$out_headers.($out_content?"\r\n".$out_content:"");
				$resp_len=strlen($response);
				
				socket_write($msgsock, $response, $resp_len);

				$combined_logline=$remote_host." - - [".date("d/M/Y:H:i:s O")."] \"".trim($tmp_arr[0])."\" ".$rq_err." ".$resp_len." \"".($htreq_headers["REFERER"]?$htreq_headers["REFERER"]:"-")."\" \"".($htreq_headers["USER-AGENT"]?$htreq_headers["USER-AGENT"]:"-")."\"\n";

				if ($conf["global"]["consolelog"]=="1") {

					echo "[".$vhost."] ".$combined_logline;
					flush();

				}

				if ($lf=@fopen($conf[$vhost]["log"], "a")) {

					fputs($lf, $combined_logline);
					fclose($lf);
				
				}

				$cnx=false;

			}

		}

		usleep(1000);

	}

	socket_close($msgsock);

}

socket_close ($sock);

techo("daemon stopped");
echo "\n";

?>
